--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   15:51:18 07/07/2010
-- Design Name:   
-- Module Name:   /home/rudenduden/workspace_vhdl/oscione3/sampling_tb.vhd
-- Project Name:  oscione3
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: sampling
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- unsigned for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
--USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY sampling_tb IS
END sampling_tb;
 
ARCHITECTURE behavior OF sampling_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT sampling
    PORT(
         clk : IN  std_logic;
         reset : IN  std_logic;
         interleave : IN  unsigned(3 downto 0);
         trigMode : IN  std_logic;
         trigPolarity : IN  std_logic;
         trigChannel : IN  std_logic;
         trigLevel : IN  unsigned(5 downto 0);
         adcA : IN  unsigned(7 downto 0);
         adcB : IN  unsigned(7 downto 0);
         FIFO : OUT  std_logic_vector(15 downto 0);
			FIFOADDR0 : out STD_LOGIC;
			FIFOADDR1 : out STD_LOGIC;
         SLWR : OUT  std_logic;
			probeTuning : out std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal reset : std_logic := '0';
   signal interleave : unsigned(3 downto 0) := (others => '0');
   signal trigMode : std_logic := '0';
   signal trigPolarity : std_logic := '0';
   signal trigChannel : std_logic := '0';
   signal trigLevel : unsigned(5 downto 0) := (others => '0');
   signal adcA : unsigned(7 downto 0) := (others => '0');
   signal adcB : unsigned(7 downto 0) := "10000000";

 	--Outputs
   signal FIFO : std_logic_vector(15 downto 0);
	signal FIFOADDR0 : STD_LOGIC;
	signal FIFOADDR1 : STD_LOGIC;
   signal SLWR : std_logic;
	signal probeTuning : std_logic;

   -- Clock period definitions
   constant clk_period : time := 20 ns;
	signal run : boolean := true;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: sampling PORT MAP (
          clk => clk,
          reset => reset,
          interleave => interleave,
          trigMode => trigMode,
          trigPolarity => trigPolarity,
          trigChannel => trigChannel,
          trigLevel => trigLevel,
          adcA => adcA,
          adcB => adcB,
          FIFO => FIFO,
          SLWR => SLWR,
			 probeTuning => probeTuning
        );

   -- Clock process definitions
   clk_process :process
   begin
	while run loop
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
	end loop;
	wait;
   end process;
	
	-- adc process definitions
   adc :process
   begin
	wait for 30 ns;
	while run loop
		adcA <= adcA+1;
		adcB <= adcB+1;
		wait for clk_period;
	end loop;
	wait;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 20 ns.
		reset <= '0';
      wait for 20 ns;
		reset <= '1';

		trigMode <= '1';
		trigChannel <= '0';
		trigLevel <= "100000";
		trigPolarity <= '1';
		interLeave <= "1000"; -- 8
      wait for clk_period*3000;

      -- insert stimulus here
		run <= false;

      wait;
   end process;

END;
